/*****************************************************************************
 * $Id:: adc.c 6615 2011-02-25 14:28:13Z nxp16893                           $
 *
 * Project: FOC SCT Application Example for LPC1800	
 *
 * Description:
 *   ADC header file
 *----------------------------------------------------------------------------
 * Software that is described herein is for illustrative purposes only
 * which provides customers with programming information regarding the
 * products. This software is supplied "AS IS" without any warranties.
 * NXP Semiconductors assumes no responsibility or liability for the
 * use of the software, conveys no license or title under any patent,
 * copyright, or mask work right to the product. NXP Semiconductors
 * reserves the right to make changes in the software without
 * notification. NXP Semiconductors also make no representation or
 * warranty that such application will be suitable for the specified
 * use without further testing or modification.
 *****************************************************************************/
#ifndef __ADC_H 
#define __ADC_H

#define ADC_DONE            (1<<31)
#define ADC_OVERRUN         (1<<30)
#define ADC_ADINT           (1<<16)

#define ADC_START_NOW		1
#define ADC_START_CTOUT_15	2
#define ADC_START_CTOUT_8	3
#define ADC_START_ADCTRIG0	4
#define ADC_START_ADCTRIG1	5
#define ADC_START_MCPWM		6

#define ADC_EDGE_RISING	 	0
#define ADC_EDGE_FALLING	1

typedef void (* ADC_CH_CALLBACK)(uint16_t value);

void vADC0Init(uint8_t channels, uint32_t clk,  uint8_t start, uint8_t edge);
void vADC1Init(uint8_t channels, uint32_t clk,  uint8_t start, uint8_t edge);
void vADC_SetChCallback(uint8_t port, uint8_t ch, ADC_CH_CALLBACK callback);
uint16_t u16ADC_ReadDR(uint8_t port, uint8_t ch);
#endif /* end __ADC_H */
/*****************************************************************************
**                            End Of File
******************************************************************************/
